<?php // $Id: lib-zones.inc.php,v 1.7.2.1 2001/11/16 12:25:31 ciaccia Exp $

/************************************************************************/
/* phpPgAds                                                             */
/* ========                                                             */
/*                                                                      */
/* Copyright (c) 2001 by the phpPgAds developers                        */
/* http://sourceforge.net/projects/phppgads                             */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/



// Define zonetypes
define ("phpAds_ZoneBanners", 0);
define ("phpAds_ZoneInteractive", 1);
define ("phpAds_ZoneRaw", 2);


/*********************************************************/
/* Rebuild zonecache                                     */
/*********************************************************/

function phpAds_RebuildZoneCache ($zoneid = '')
{
	global $phpAds_tbl_zones, $phpAds_tbl_banners, $phpAds_zone_cache;
	
	if ($zoneid == '')
	{
		$res_zones = phpAds_dbQuery("
			SELECT 
				*
			FROM 
				$phpAds_tbl_zones
			") or phpAds_sqlDie();
		
		while ($row_zones = phpAds_dbFetchArray($res_zones))
		{
			phpAds_RebuildZoneCache ($row_zones['zoneid']);
		}
	}
	else
	{
		// Get zone
		$zoneres = phpAds_dbQuery("SELECT * FROM $phpAds_tbl_zones WHERE zoneid='$zoneid' ");
		
		if (phpAds_dbNumRows($zoneres) > 0)
		{
			$zone = phpAds_dbFetchArray($zoneres);
			
			// Set what parameter to zone settings
			if (isset($zone['what']) && $zone['what'] != '')
				$what = $zone['what'];
			else
				$what = '';
		}
		else
			$what = '';
		
		
		if ($phpAds_zone_cache)
		{
			$precondition = '';
			
			// Size preconditions
			if ($zone['width'] > -1)
				$precondition .= " AND $phpAds_tbl_banners.width = ".$zone['width']." ";
			
			if ($zone['height'] > -1)
				$precondition .= " AND $phpAds_tbl_banners.height = ".$zone['height']." ";
			
			
			// Get banners
			$select = phpAds_buildQuery ($what, 1, $precondition);
			$res    = phpAds_dbQuery($select);
			
			// Build array for further processing...
			$rows = array();
			$weightsum = 0;
			while ($tmprow = phpAds_dbFetchArray($res))
			{
				// weight of 0 disables the banner
				if ($tmprow['weight'])
				{
					// We can safely put the large object oid into cache
					/*
					if ($tmprow['format'] == 'gif' ||
						$tmprow['format'] == 'jpeg' ||
						$tmprow['format'] == 'png' ||
						$tmprow['format'] == 'swf')
					{
						$tmprow['banner'] = '';
					}
					*/
					
					$weightsum += ($tmprow['weight'] * $tmprow['clientweight']);
					$rows[] = $tmprow; 
				}
			}

			//This is needed as Postgres doesn't allow to get the large object size
			$cachecontents = serialize (array ($weightsum, $rows));
			$cachesize = strlen($cachecontents);
			$cachecontents = addslashes ($cachecontents);

			// Use large objects
			phpAds_dbQuery("BEGIN") or phpAds_sqlDie();
			
			if ($cache_oid = @pg_locreate($GLOBALS['phpAds_db_link']))
			{
				if ($cache_fd = @pg_loopen($GLOBALS['phpAds_db_link'], $cache_oid, "w"))
				{
					if (@pg_lowrite($cache_fd, $cachecontents))
					{
						@pg_loclose($cache_fd);

						$cachecontents = $cache_oid;

						if (!empty($zone['cachecontents']))
							@pg_lounlink($GLOBALS['phpAds_db_link'], $zone['cachecontents']);
					}
				}
			}
			
			phpAds_dbQuery("COMMIT") or phpAds_sqlDie();

			$cachetimestamp = 'NOW()';
		}
		else
		{
			$cachecontents = '';
			$cachetimestamp = 'NULL';
			$cachesize = 0;
		}

		phpAds_dbQuery("UPDATE $phpAds_tbl_zones SET cachecontents='$cachecontents', cachetimestamp=$cachetimestamp, cachesize = $cachesize WHERE zoneid='$zoneid' ");
	}
}



/*********************************************************/
/* Determine if a banner included in a zone              */
/*********************************************************/

function phpAds_IsBannerInZone ($bannerid, $zoneid)
{
	global $phpAds_tbl_zones;
	
	if (isset($zoneid) && $zoneid != '')
	{
		$res = phpAds_dbQuery("
			SELECT
				*
			FROM
				$phpAds_tbl_zones
			WHERE
				zoneid = $zoneid
			") or phpAds_sqlDie();
		
		if (phpAds_dbNumRows($res))
		{
			$zone = phpAds_dbFetchArray($res);
			$what_array = explode(",", $zone['what']);
			
			for ($k=0; $k < count($what_array); $k++)
			{
				if (substr($what_array[$k],0,9) == "bannerid:" && 
				    substr($what_array[$k],9) == $bannerid)
				{
					return (true);
				}
			}
		}
	}
	
	return (false);
}



/*********************************************************/
/* Add a banner to a zone                                */
/*********************************************************/

function phpAds_ToggleBannerInZone ($bannerid, $zoneid)
{
	global $phpAds_tbl_zones;
	
	
	if (isset($zoneid) && $zoneid != '')
	{
		$res = phpAds_dbQuery("
			SELECT
				*
			FROM
				$phpAds_tbl_zones
			WHERE
				zoneid = $zoneid
			") or phpAds_sqlDie();
		
		if (phpAds_dbNumRows($res))
		{
			$zone = phpAds_dbFetchArray($res);
			$what_array = explode(",", $zone['what']);
			$available = false;
			$changed = false;
			
			for ($k=0; $k < count($what_array); $k++)
			{
				if (substr($what_array[$k],0,9) == "bannerid:" && 
				    substr($what_array[$k],9) == $bannerid)
				{
					// Remove from array
					unset ($what_array[$k]);
					$available = true;
					$changed = true;
				}
			}
			
			if ($available == false)
			{
				// Add to array
				$what_array[] = 'bannerid:'.$bannerid;
				$changed = true;
			}
			
			if ($changed == true)
			{
				// Convert back to a string
				$zone['what'] = implode (",", $what_array);
				
				// Store string back into database
				$res = phpAds_dbQuery("
					UPDATE
						$phpAds_tbl_zones
					SET 
						what = '".$zone['what']."'
					WHERE
						zoneid = $zoneid
					") or phpAds_sqlDie();
				
				// Rebuild Cache
				phpAds_RebuildZoneCache ($zoneid);
			}
		}
	}
	
	return (false);
}

?>